Attribute VB_Name = "ConsolaVB"
' Manejo de Consola
' @version 0.1, Gustavo Brown
'

Option Explicit
Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As Any) As Long
Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As Any) As Long
Private Declare Function GetStdHandle Lib "kernel32" (ByVal nStdHandle As Long) As Long
Public Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Long) As Long


Private Const STDIN_HANDLE = -10&
Private Const STDOUT_HANDLE = -11&
Private Const STDERR_HANDLE = -12&

Private stdIn As Long
Private stdOut As Long
Private stdErr As Long


Sub Main()
InitConsoleManager
Dim msg As String

SendCommand ("Este mensaje est antes del Listo! 1")
SendCommand ("Este mensaje est antes del Listo! 2")
SendCommand ("Este mensaje est antes del Listo! 3")

SendCommand ("listo")

SendMessage ("Este mensaje est despues del Listo!!")
SendMessage ("Ahora espero al primer mensaje y le hago un echo")

msg = getMessage
SendMessage ("VisualBasic ConsoleManager v0.1, Gustavo Brown")
SendMessage ("Mensaje recibido del Juez: " + msg)
SendMessage ("Voy a enviar un comando invalido desde VisualBasic...")
SendCommand ("Este es un comando invalido")
SendMessage ("Fin")
End Sub


'Inicializa el manejo de Consola
'
Sub InitConsoleManager()
stdIn = GetStdHandle(STDIN_HANDLE)
stdOut = GetStdHandle(STDOUT_HANDLE)
stdErr = GetStdHandle(STDERR_HANDLE)
End Sub

'Enva el comando al Juez (agrega automaticamente el CR+LF)
'@param cmd Comando a enviar
'
Sub SendCommand(cmd As String)
Dim llResult As Long
   WriteFile stdOut, cmd + vbCrLf, Len(cmd) + 2, llResult, ByVal 0&
   FlushFileBuffers stdOut
End Sub

'Enva el mensaje al Juez (agrega automaticamente el CR+LF)
'@param cmd Comando a enviar
'
Sub SendMessage(msg As String)
Dim llResult As Long
   WriteFile stdErr, msg + vbCrLf, Len(msg) + 2, llResult, ByVal 0&
   FlushFileBuffers stdErr
End Sub

'Obtiene un mensaje del Juez
'@return String con el mensaje
'
Function getMessage() As String
Dim buffer As String
Dim bRead As Long
buffer = String(1, 0)
getMessage = ""
   Do
      bRead = 1
      If ReadFile(stdIn, ByVal buffer, 1, bRead, ByVal 0&) Then
        If buffer = vbLf Then
            Exit Do
        Else
           If buffer <> vbCr Then
              getMessage = getMessage + buffer
           End If
        End If
      End If
   Loop
End Function

